#!/usr/bin/perl -w
use strict;

BEGIN { $| = 1; print "1..20\n"; }
my $loaded = 1;
END {print "not ok 1\n" unless $loaded;}
use MCS::CGI::Conf;
print "ok 1\n";

######################### End of black magic.


my $test = 1;
my $cfg;

$ENV{HTTP_MCS_ADMIN_GRP} = 'wwwadm';

chmod 0604, 'world_readable'
  or die "Cannot chmod 'world_readable' to 0604: $!\n";
chmod 0602, 'world_writable'
  or die "Cannot chmod 'world_writable' to 0602: $!\n";
chmod 0600, 'test.cfg'
  or die "Cannot chmod 'test.cfg' to 0600: $!\n";
chmod 0600, 'global.cfg'
  or die "Cannot chmod 'global.cfg' to 0600: $!\n";
chmod 0600, 'default.cfg'
  or die "Cannot chmod 'default.cfg' to 0600: $!\n";

$test++;
print defined MCS::CGI::Conf::is_safe('___nonexistent_file___') ?
  "not ok $test\n" : "ok $test\n";

$test++;
print MCS::CGI::Conf::is_safe('world_readable') ?
  "not ok $test\n" : "ok $test\n";

$test++;
print MCS::CGI::Conf::is_safe('world_writable') ?
  "not ok $test\n" : "ok $test\n";

$test++;
print MCS::CGI::Conf::is_safe('test.cfg') ?
  "ok $test\n" : "not ok $test\n";

$test++;
$cfg = MCS::CGI::Conf::read_config();
print $cfg ? ($cfg->Sections ? "not ok $test\n" : "ok $test\n") : "ok $test\n";


$test++;
$cfg = MCS::CGI::Conf::read_config('');
print $cfg ? ($cfg->Sections ? "not ok $test\n" : "ok $test\n") : "ok $test\n";

$test++;
print STDERR "\nExpect an Error on STDERR\n";
eval { $cfg = MCS::CGI::Conf::read_config('___nonexistent_file___') };
print $@ =~ /^Cannot check/ ? "ok $test\n" : "not ok $test\n";


$test++;
eval { $cfg = MCS::CGI::Conf::read_config('world_readable') };
print $@ =~ /insecure/ ? "ok $test\n" : "not ok $test\n";


$test++;
eval { $cfg = MCS::CGI::Conf::read_config('world_writable') };
print $@ =~ /insecure/ ? "ok $test\n" : "not ok $test\n";

$test++;
eval{ $cfg = MCS::CGI::Conf::read_config('world_readable.ini') };
print $@ ? "not ok $test\n" : "ok $test world_readable.ini is no longer world_readable\n";



$test++;
eval { $cfg = MCS::CGI::Conf::read_config('test.cfg') };
if (@Config::IniFiles::errors) {
  print "not ok $test: @Config::IniFiles::errors\n";
}
else {
  print $@ ? "not ok $test: $@\n" : "ok $test\n";
}

$test++;
$ENV{PATH_TRANSLATED}      = 'test.cfg';
$ENV{HTTP_MCS_GLOBAL_CFG}  = 'global.cfg';
$ENV{HTTP_MCS_DEFAULT_CFG} = 'default.cfg';
eval { $cfg = new MCS::CGI::Conf };
print $@ ? "not ok $test: $@\n" : "ok $test\n";

$test++;
print $cfg->val('test1', 'one') eq 'value1' ? "ok $test\n" : "not ok $test\n";

$test++;
print
  $cfg->val('test1', 'three') eq 'value33' ? "ok $test\n" : "not ok $test\n";

$test++;
print $cfg->val('test1', 'four') eq 'value4' ? "ok $test\n" : "not ok $test\n";

$test++;
print $cfg->val('test2', 'six') eq 'value66' ? "ok $test\n" : "not ok $test\n";

$test++;
print $cfg->val('test2', 'four') eq 'value4' ? "ok $test\n" : "not ok $test\n";

$test++;
print
  $cfg->val('test2', 'seven') eq 'value7' ? "ok $test\n" : "not ok $test\n";

$test++;
print defined $cfg->val('test2', 'one') ? "not ok $test\n" : "ok $test\n";


print <<EOF;

test.pl is fininshed now. You have recived some error massages on STDOUT
which is normal. Nico Tillmann decided to give some debugging hints
within the Modul MCS::CGI::Conf

If you don't want to see these error massages
perl test.pl 2>/dev/null

EOF
